/*#################################################################################################
	For		:	Xmega 
	Version	:	1.0
	Date	:	30.07.2013
	Autor	:	Martin Junghans
	Hardware:	ATXmega, 32MHz at 16Mhz extern, Wiznet, Webserver
//################################################################################################*/

#include "main.h"
			
//########################################################################################## initialisierung
void initialisierung(void)
{	
	cli();
	//####################################### nit_clock
	CLKSYS_XOSC_Config( OSC_FRQRANGE_12TO16_gc, false, OSC_XOSCSEL_XTAL_16KCLK_gc );// Quarz config
	CLKSYS_Enable( OSC_XOSCEN_bm );													// enable oscillator
	CLKSYS_PLL_Config( OSC_PLLSRC_XOSC_gc, 8 );										// config PLL - Quarz + 8x -->128Mhz
	CLKSYS_Enable( OSC_PLLEN_bm );													// PLL enable
	CLKSYS_Prescalers_Config( CLK_PSADIV_1_gc, CLK_PSBCDIV_2_2_gc );				// Prescaller A, B, C --> Mainclock 32Mhz
	while ( !(CLKSYS_IsReady( OSC_PLLRDY_bm )) ) ;									// Wait for it to stabilize

	CLKSYS_Main_ClockSource_Select( CLK_SCLKSEL_PLL_gc );							// Source for Main Clock
	CLKSYS_Disable( OSC_XOSCEN_bm );												// Oscillator disable	
	
  	//####################################### Ports 		
	sbi(PORTF.DIR,4);	sbi(PORTF.OUT,4);				// output	LED 4
	sbi(PORTF.DIR,5);	sbi(PORTF.OUT,5);				// output	LED 5
	sbi(PORTF.DIR,6);	sbi(PORTF.OUT,6);				// output	LED 6	  
	sbi(PORTF.DIR,7);	sbi(PORTF.OUT,7);				// output	LED 7	  

	//####################################### Initialize UART 
	cbi(PORTE.DIR,2);		// PE2 (RXE0) as input
	sbi(PORTE.DIR,3);		// PE3 (TXE0) as output 	
	usart_init(&USART_E0, &USARTE0, USART_BAUD_SELECT_DOUBLE_SPEED(BAUDRATE_E0, F_CPU) , USART_DREINTLVL_LO_gc); 
	
	//####################################### enable Interrupts 
	PMIC.CTRL |= PMIC_HILVLEN_bm |PMIC_MEDLVLEN_bm|PMIC_LOLVLEN_bm;		//Interrupts Highlevel,Mediumlevel und Lowlevel freigeben
	sei();
}
//########################################################################################## Int UARTD RXD
ISR(USARTE0_RXC_vect)	{	USART_RXComplete(&USART_E0);				}
ISR(USARTE0_DRE_vect)	{	USART_DataRegEmpty(&USART_E0);				}		
//##########################################################################################
int main (void) 
{   		
	initialisierung();										// Load controller setup

	tcp_init();
	_delay_ms(3000);		
	
	while(1) 
	{          
	//#################### Wiznet
	tcp_run();		

	//#################### while end  
	}                                   
}

