/*#################################################################################################
	For		:	Xmega 
	Version	:	1.0
	Date	:	30.07.2013
	Autor	:	Martin Junghans
	Hardware:	ATXmega, 32MHz at 16Mhz extern, Wiznet, Webserver
//################################################################################################*/

#ifndef MAIN_H_
#define MAIN_H_

//#################################### CPU clock
#undef F_CPU										// set for delays
#define F_CPU 32000000UL							// should always precede <avr/delay.h>


#include <stdlib.h>
#include <avr/io.h>
#include <stdio.h>
#include <stddef.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <string.h>
#include <util/delay.h>
#include <util/atomic.h>

#include "macros.h"
#include "avr_compiler.h"
#include "clksys_driver.h"
#include "usart_driver.h"
#include "spi_driver.h"

#include "tcp/tcp.h"

//#################################### LED macros
#define LED0_ON		cbi(PORTF.OUT,	 4)
#define LED0_TG		toggle(PORTF.OUT,4)
#define LED0_OF		sbi(PORTF.OUT,	 4)

#define LED1_ON		cbi(PORTF.OUT,	 5)
#define LED1_TG		toggle(PORTF.OUT,5)
#define LED1_OF		sbi(PORTF.OUT,	 5)

#define LED2_ON		cbi(PORTF.OUT,	 6)
#define LED2_TG		toggle(PORTF.OUT,6)
#define LED2_OF		sbi(PORTF.OUT,	 6)

#define LED3_ON		cbi(PORTF.OUT,	 7)
#define LED3_TG		toggle(PORTF.OUT,7)
#define LED3_OF		sbi(PORTF.OUT,	 7)



//#################################### UART 
char 							buffer[12];					// Buffer fr Text Displays oder UART Funktionen

#define	BAUDRATE_E0				115200						// 115200, 57600, 256000, ...
USART_data_t					USART_E0;					// USART data struct used in example. 



#endif /* MAIN_H_ */
