/*#################################################################################################
	For		:	Xmega 
	Version	:	1.0
	Date	:	30.07.2013
	Autor	:	Martin Junghans
	Hardware:	ATXmega, 32MHz at 16Mhz extern, Wiznet, Webserver
//################################################################################################*/

#include "wiznet_driver.h"

/*
#define WIZNET_INT 		1
#define WIZNET_RESET	0
#define WIZNET_CS		4
#define WIZNET_PORT		PORTE

//##########################################################################################
uint8_t wiz_write1(uint8_t addressH, uint8_t addressL, uint8_t data)
{
	uint8_t result = 0;
	cbi(WIZNET_PORT.OUT,WIZNET_CS);						// LOW;
	SPI_MasterTransceiveByte(&spiMasterE,WIZ_WRITE_OPCODE);			// write OP-Code
	SPI_MasterTransceiveByte(&spiMasterE,addressH);		// address H
	SPI_MasterTransceiveByte(&spiMasterE,addressL);		// address L
	result = SPI_MasterTransceiveByte(&spiMasterE,data);// data
	sbi(WIZNET_PORT.OUT,WIZNET_CS);						// HIGH;
	return result;
}
//##########################################################################################
uint8_t wiz_read1(uint8_t addressH, uint8_t addressL)
{
	uint8_t result = 0;
	cbi(WIZNET_PORT.OUT,WIZNET_CS);							// LOW;
	SPI_MasterTransceiveByte(&spiMasterE,WIZ_READ_OPCODE);				// read OP-Code
	SPI_MasterTransceiveByte(&spiMasterE,addressH);			// address H
	SPI_MasterTransceiveByte(&spiMasterE,addressL);			// address L
	result = SPI_MasterTransceiveByte(&spiMasterE,0x00);	// dummy data
	sbi(WIZNET_PORT.OUT,WIZNET_CS);							// HIGH;
	return result;
}
*/

//##########################################################################################
uint8_t wiz_write(WIZ_data_t *wiz_data, uint8_t addressH, uint8_t addressL, uint8_t data)
{
	uint8_t result = 0;
	cbi(wiz_data->hw_port->OUT, wiz_data->hw_pin_cs);							// LOW;
	SPI_MasterTransceiveByte(wiz_data->hw_spi,WIZ_WRITE_OPCODE);				// write OP-Code
	SPI_MasterTransceiveByte(wiz_data->hw_spi,addressH);						// address H
	SPI_MasterTransceiveByte(wiz_data->hw_spi,addressL);						// address L
	result = SPI_MasterTransceiveByte(wiz_data->hw_spi,data);					// data
	sbi(wiz_data->hw_port->OUT, wiz_data->hw_pin_cs);							// HIGH;
	return result;
}
//##########################################################################################
uint8_t wiz_read(WIZ_data_t *wiz_data, uint8_t addressH, uint8_t addressL)
{
	uint8_t result = 0;
	cbi(wiz_data->hw_port->OUT, wiz_data->hw_pin_cs);							// LOW;
	SPI_MasterTransceiveByte(wiz_data->hw_spi, WIZ_READ_OPCODE);				// read OP-Code
	SPI_MasterTransceiveByte(wiz_data->hw_spi, addressH);						// address H
	SPI_MasterTransceiveByte(wiz_data->hw_spi, addressL);						// address L
	result = SPI_MasterTransceiveByte(wiz_data->hw_spi, 0x00);					// dummy data
	sbi(wiz_data->hw_port->OUT, wiz_data->hw_pin_cs);							// HIGH;
	return result;
}

//##########################################################################################
void wiz_init( WIZ_data_t * wiz_data)
{

	//####################################### CS
	sbi(wiz_data->hw_port->DIR,wiz_data->hw_pin_cs);	sbi(wiz_data->hw_port->OUT, wiz_data->hw_pin_cs);		// Ausgang		
 
	//####################################### Reset
	sbi(wiz_data->hw_port->DIR,wiz_data->hw_pin_reset);	sbi(wiz_data->hw_port->OUT, wiz_data->hw_pin_reset);		// Ausgang		
 	cbi(wiz_data->hw_port->OUT,wiz_data->hw_pin_reset);					// LOW
 	   _delay_ms(1);
 	sbi(wiz_data->hw_port->OUT,wiz_data->hw_pin_reset);					// HIGH

	//####################################### TCP/IP Setting the Wiznet W5100 Mode Register
	wiz_write(wiz_data,WIZ_COM_REG,S_MODE_REG  , 0x80);          // (MR) reset					
	wiz_write(wiz_data,WIZ_COM_REG,WIZ_INTM_REG, 0x01);			// (IMR) int socket0 enable
	// 	wiz_write(wiz_data,0x0017, 0x00);							// (RTR) timeout period 2ms (0x0014)
	//	wiz_write(wiz_data,0x0018, 0x14);
	// 	wiz_write(wiz_data,0x0019, 0x08);							// (RCR) number of re-transmission
	// 	wiz_write(wiz_data,0x0028, 0x28);							// PTIMER

	// Setting the Wiznet W5100 Gateway Address (GAR): 0x0001 to 0x0004
	wiz_write(wiz_data,WIZ_COM_REG, WIZ_GTW_REG + 0,wiz_data->tcp_gtw_addr[0]);
	wiz_write(wiz_data,WIZ_COM_REG, WIZ_GTW_REG + 1,wiz_data->tcp_gtw_addr[1]);
	wiz_write(wiz_data,WIZ_COM_REG, WIZ_GTW_REG + 2,wiz_data->tcp_gtw_addr[2]);
	wiz_write(wiz_data,WIZ_COM_REG, WIZ_GTW_REG + 3,wiz_data->tcp_gtw_addr[3]);

	// Setting the Wiznet W5100 Source Address Register (SAR): 0x0009 to 0x000E
	wiz_write(wiz_data,WIZ_COM_REG, WIZ_MAC_REG + 0,wiz_data->tcp_mac_addr[0]);
	wiz_write(wiz_data,WIZ_COM_REG, WIZ_MAC_REG + 1,wiz_data->tcp_mac_addr[1]);
	wiz_write(wiz_data,WIZ_COM_REG, WIZ_MAC_REG + 2,wiz_data->tcp_mac_addr[2]);
	wiz_write(wiz_data,WIZ_COM_REG, WIZ_MAC_REG + 3,wiz_data->tcp_mac_addr[3]);
	wiz_write(wiz_data,WIZ_COM_REG, WIZ_MAC_REG + 4,wiz_data->tcp_mac_addr[4]);
	wiz_write(wiz_data,WIZ_COM_REG, WIZ_MAC_REG + 5,wiz_data->tcp_mac_addr[5]);

	// Setting the Wiznet W5100 Sub Mask Address (SUBR): 0x0005 to 0x0008
	wiz_write(wiz_data,WIZ_COM_REG, WIZ_SUB_REG+ 0,wiz_data->tcp_sub_mask[0]);
	wiz_write(wiz_data,WIZ_COM_REG, WIZ_SUB_REG+ 1,wiz_data->tcp_sub_mask[1]);
	wiz_write(wiz_data,WIZ_COM_REG, WIZ_SUB_REG+ 2,wiz_data->tcp_sub_mask[2]);
	wiz_write(wiz_data,WIZ_COM_REG, WIZ_SUB_REG+ 3,wiz_data->tcp_sub_mask[3]);

	// Setting the Wiznet W5100 IP Address (SIPR): 0x000F to 0x0012
	wiz_write(wiz_data,WIZ_COM_REG, WIZ_IP_REG + 0,wiz_data->tcp_ip_addr[0]);
	wiz_write(wiz_data,WIZ_COM_REG, WIZ_IP_REG + 1,wiz_data->tcp_ip_addr[1]);
	wiz_write(wiz_data,WIZ_COM_REG, WIZ_IP_REG + 2,wiz_data->tcp_ip_addr[2]);
	wiz_write(wiz_data,WIZ_COM_REG, WIZ_IP_REG + 3,wiz_data->tcp_ip_addr[3]);    

	// Setting the Wiznet W5100 RX and TX Memory Size (2KB),
	wiz_write(wiz_data,WIZ_COM_REG, WIZ_RXMS_REG,((NET_MEMALLOC & 0x00FF) >> 8 ));
	wiz_write(wiz_data,WIZ_COM_REG, WIZ_TXMS_REG,((NET_MEMALLOC & 0x00FF) >> 0 ));

	// 	wiz_write(wiz_data,S0_CR, S_MAX_SEGMENT_SIZE+0, config.socket0_SegSize_12);
	// 	wiz_write(wiz_data,S0_CR, S_MAX_SEGMENT_SIZE+1, config.socket0_SegSize_13);
}

//##########################################################################################
uint8_t wiz_sock_init(WIZ_data_t *wiz_data,uint8_t sock, uint8_t ethProtocol, uint16_t tcpPort )
{  
	uint8_t result = 0;

		 
	if(wiz_read(wiz_data, sock, S_STATUS_REG) == SR_CLOSED)						// make sure we close the socket first
	{			
		wiz_sock_close(wiz_data, sock);
	}
	
	wiz_write(wiz_data, sock, S_MODE_REG, ethProtocol);							// assigned socket mode register

	wiz_write(wiz_data, sock, S_SOURCE_PORT+0, ((tcpPort & 0xFF00) >> 8 ));		// open the new socket
	wiz_write(wiz_data, sock, S_SOURCE_PORT+1, ((tcpPort & 0x00FF) >> 0 ));
	
	wiz_write(wiz_data, sock, S_COMMAND_REG, CR_OPEN);							// open socket

	while(wiz_read(wiz_data, sock, S_COMMAND_REG));								// wait for opening process
	
	result = wiz_read(wiz_data, sock, S_STATUS_REG);								
		
	if( result == SR_INIT)	{result = 1;}										//check for init status
	else					{result = 0; wiz_sock_close(wiz_data, sock);}
		
	return result;
}
//##########################################################################################
uint8_t	wiz_sock_connectServer(WIZ_data_t *wiz_data, uint8_t sock, uint16_t dest_port)		// destination ip
{  
	uint8_t result = 0;

	wiz_write(wiz_data, sock, S_DEST_IP_ADDR + 0, wiz_data->tcp_ip_dest[0]);
	wiz_write(wiz_data, sock, S_DEST_IP_ADDR + 1, wiz_data->tcp_ip_dest[1]);
	wiz_write(wiz_data, sock, S_DEST_IP_ADDR + 2, wiz_data->tcp_ip_dest[2]);
	wiz_write(wiz_data, sock, S_DEST_IP_ADDR + 3, wiz_data->tcp_ip_dest[3]);
	
	wiz_write(wiz_data, sock, S_DEST_PORT    + 0, ((dest_port & 0x00FF) >> 8 ));
	wiz_write(wiz_data, sock, S_DEST_PORT    + 1, ((dest_port & 0x00FF) >> 0 ));
	
	wiz_write(wiz_data, sock, S_COMMAND_REG, CR_CONNECT);							// connect the socket
	
	while(wiz_read(wiz_data, sock, S_COMMAND_REG));								// wait for connecting process

	result = wiz_read(wiz_data, sock, S_STATUS_REG);								
		
	if( result == SR_INIT)	{result = 1;}										//check for init status
	else					{result = 0; wiz_sock_close(wiz_data, sock);}
			
	return result;	
}
//##########################################################################################
void	wiz_sock_disconnect(WIZ_data_t *wiz_data,uint8_t sock)
{		
	wiz_write(wiz_data, sock, S_COMMAND_REG, CR_DISCONECT);			// send disconnect command		
	while(wiz_read(wiz_data, sock, S_COMMAND_REG));					// wait for disconnection process
}
//##########################################################################################
void	wiz_sock_close(WIZ_data_t *wiz_data,uint8_t sock)
{
	wiz_write(wiz_data, sock, S_COMMAND_REG, CR_CLOSE);				// Send Close Command
	while(wiz_read(wiz_data, sock, S_COMMAND_REG));					// Waiting until the Socket CR is clear
}
//##########################################################################################
uint8_t wiz_sock_listen(WIZ_data_t *wiz_data,uint8_t sock)
{
	uint8_t result = 0;

	if(wiz_read(wiz_data, sock, S_STATUS_REG) == SR_INIT)
	{		
		wiz_write(wiz_data, sock, S_COMMAND_REG, CR_LISTEN);					// send the listen command		
		
		while(wiz_read(wiz_data, sock, S_COMMAND_REG))						// wait for listening process	
		{
			;
		}
		
		if(wiz_read(wiz_data, sock, S_STATUS_REG) == SR_LISTEN)				// check for listen status
			result = 1;
		else
			wiz_sock_close(wiz_data, sock);
	}
	return result;
}
//##########################################################################################
uint8_t wiz_sock_send(WIZ_data_t *wiz_data, uint8_t sock)
{
	uint16_t buflen = strlen(wiz_data->bufRXTX);
	uint16_t txFreeSize = 0;
	uint16_t timeout = 0;
	uint16_t ptr = 0;
	uint16_t offaddr = 0;
	uint16_t realaddr = 0;
	
	
	if(buflen < 1)										return 0;	// nothing to send
	if(wiz_read(wiz_data, sock, S_STATUS_REG) != SR_ESTABLISHED)		return 0;	// not established

	// Make sure the TX Free Size Register is available
	txFreeSize = wiz_read(wiz_data, sock, S_TX_FREE_SIZE + 0);
	txFreeSize = (((txFreeSize & 0x00FF) << 8 ) + wiz_read(wiz_data, sock, S_TX_FREE_SIZE + 1));

	while(txFreeSize < buflen)
	{
		txFreeSize = wiz_read(wiz_data, sock, S_TX_FREE_SIZE+0);
		txFreeSize = (((txFreeSize & 0x00FF) << 8 ) + wiz_read(wiz_data, sock, S_TX_FREE_SIZE+1));

		if(timeout++ > 100)							// Timeout for approx 1000ms
		{					
			wiz_sock_disconnect(wiz_data, sock);				// Tx Free Size Error!
			return 0;
		}
	}
		
	// Read the Tx Write Pointer
	ptr = wiz_read(wiz_data, sock, S_TX_WRITE_POINTER+0);
	offaddr = (((ptr & 0x00FF) << 8) + wiz_read(wiz_data, sock, S_TX_WRITE_POINTER+1));

	for(uint16_t i = 0; i < buflen; i++)
	{
		// Calculate the real W5100 physical Tx Buffer Address
		realaddr = WIZ_TX_BUF_ADDR + (offaddr & WIZ_TX_BUF_MASK);
		
		// Copy the application data to the W5100 Tx Buffer
		wiz_write(wiz_data, ((realaddr & 0xff00) >> 8), (realaddr & 0x00ff), wiz_data->bufRXTX[i]);
		offaddr++;
	}

	// increase the S_TX_WRITE_POINTER value, so it point to the next transmit
	wiz_write(wiz_data, sock, S_TX_WRITE_POINTER+0, (offaddr & 0xFF00) >> 8);
	wiz_write(wiz_data, sock, S_TX_WRITE_POINTER+1, (offaddr & 0x00FF));
		
	wiz_write(wiz_data, sock, S_COMMAND_REG, CR_SEND);		// Now Send the SEND command		
	while(wiz_read(wiz_data,sock, S_COMMAND_REG))			// Wait for Sending Process
	{
		;
	}		

	return 1;
}
//##########################################################################################
uint8_t wiz_sock_recv(WIZ_data_t *wiz_data,uint8_t sock, uint8_t *buf, uint16_t buflen)
{
	uint16_t ptr = 0;
	uint16_t offaddr = 0;
	uint16_t realaddr = 0;

	if(buflen <= 0)		return 0;

	// If the request size > RX_BUF_MAX, just truncate it
	if(buflen > RX_BUF_MAX)	buflen = RX_BUF_MAX - 2;

	// Read the Rx Read Pointer
	ptr		= wiz_read(wiz_data, sock, S_RX_READ_POINTER + 0);
	offaddr = (((ptr & 0x00FF) << 8 ) + wiz_read(wiz_data, sock, S_RX_READ_POINTER + 1));

	while(buflen)
	{
		buflen--;
		realaddr = WIZ_RX_BUF_ADDR + (offaddr & WIZ_RX_BUF_MASK);
		*buf = (char)(0x00FF & wiz_read(wiz_data, ((realaddr & 0xff00) >> 8), (realaddr & 0x00ff)));
		offaddr++;
		buf++;
	}
	*buf = '\0';			// String terminated character

	// Increase the S0_RX_RD value, so it point to the next receive
	wiz_write(wiz_data, sock, S_RX_READ_POINTER+0, (offaddr & 0xFF00) >> 8);
	wiz_write(wiz_data, sock, S_RX_READ_POINTER+1, (offaddr & 0x00FF) >> 0);

	// Now Send the RECV command
	wiz_write(wiz_data, sock, S_COMMAND_REG, CR_RECV);

	return 1;
}
//##########################################################################################
uint16_t wiz_sock_recvSize(WIZ_data_t *wiz_data,uint8_t sock)
{	
	return ((wiz_read(wiz_data, sock, S_RX_RECEIVED_SIZE+0) & 0x00FF) << 8) + wiz_read(wiz_data, sock, S_RX_RECEIVED_SIZE+1);
}